function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys, key, i;
    if (typeof Reflect !== "undefined" && Reflect.ownKeys) {
        sourceKeys = Reflect.ownKeys(source);
        for(i = 0; i < sourceKeys.length; i++){
            key = sourceKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
        return target;
    }
    target = _object_without_properties_loose(source, excluded);
    if (Object.getOwnPropertySymbols) {
        sourceKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceKeys.length; i++){
            key = sourceKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys = Object.getOwnPropertyNames(source), key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _to_array(arr) {
    return _array_with_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
import React, { forwardRef, useMemo, useCallback, useRef } from 'react';
import { useForkRef } from '../../hooks';
import { TabItemRefs, TabsContext } from './TabsContext';
import { Tabs } from './Tabs';
import { TabItem } from './TabItem';
var Keys = /*#__PURE__*/ function(Keys) {
    Keys[Keys["end"] = 35] = "end";
    Keys[Keys["home"] = 36] = "home";
    Keys[Keys["left"] = 37] = "left";
    Keys[Keys["right"] = 39] = "right";
    return Keys;
}(Keys || {});
/**
 * Функция для создания `TabController`, которая дает возможность
 * кастомизировать стили, при этом сохраняя единый интерфейс и функционал.
 */ export function createTabsController() {
    var ListComponent = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Tabs, ItemComponent = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : TabItem;
    // eslint-disable-next-line prefer-arrow-callback
    return /*#__PURE__*/ forwardRef(function TabsController(_0, _1) {
        var _ref = [
            _0,
            _1
        ], _ref1 = _to_array(_ref), _ref2 = _ref1[0], _rest = _ref1.slice(1), items = _ref2.items, index = _ref2.index, autoscroll = _ref2.autoscroll, onIndexChange = _ref2.onIndexChange, rest = _object_without_properties(_ref2, [
            "items",
            "index",
            "autoscroll",
            "onIndexChange"
        ]), _rest1 = _sliced_to_array(_rest, 1), outerRef = _rest1[0];
        var disabled = rest.disabled;
        var refs = useMemo(function() {
            return new TabItemRefs();
        }, []);
        var innerRef = useRef(null);
        var ref = useForkRef(outerRef, innerRef);
        var onItemFocus = useCallback(function(event) {
            var _innerRef_current;
            if (disabled) {
                return;
            }
            var focusIndex = refs.items.findIndex(function(itemRef) {
                return itemRef.current === event.target;
            });
            var focusItem = refs.items[focusIndex];
            if (focusIndex === index) {
                return;
            }
            onIndexChange === null || onIndexChange === void 0 ? void 0 : onIndexChange(focusIndex);
            var parent = (_innerRef_current = innerRef.current) === null || _innerRef_current === void 0 ? void 0 : _innerRef_current.parentNode;
            if (autoscroll && parent && (focusItem === null || focusItem === void 0 ? void 0 : focusItem.current)) {
                var _focusItem_current;
                var _ref = (_focusItem_current = focusItem.current) === null || _focusItem_current === void 0 ? void 0 : _focusItem_current.getBoundingClientRect(), x = _ref.x, width = _ref.width;
                var _parent_getBoundingClientRect = parent.getBoundingClientRect(), parentX = _parent_getBoundingClientRect.x, parentWidth = _parent_getBoundingClientRect.width;
                var relativeX = x - parentX;
                var style = window.getComputedStyle(parent);
                var marginLeft = Number.parseInt(style.marginLeft, 10);
                var marginRight = Number.parseInt(style.marginRight, 10);
                if (relativeX < -marginLeft) {
                    parent.scrollLeft += relativeX + marginLeft;
                    return;
                }
                if (parentWidth <= relativeX + width - marginRight) {
                    parent.scrollLeft += relativeX + width - parentWidth - marginRight;
                }
            }
        }, [
            refs,
            innerRef,
            index,
            onIndexChange,
            disabled
        ]);
        var onKeyDown = useCallback(function(event) {
            if (disabled) {
                return;
            }
            var minIndex = 0;
            var maxIndex = refs.items.length - 1;
            var nextIndex;
            switch(event.keyCode){
                case 35:
                    nextIndex = maxIndex;
                    break;
                case 37:
                    nextIndex = index > minIndex ? index - 1 : index;
                    break;
                case 39:
                    nextIndex = index < maxIndex ? index + 1 : index;
                    break;
                case 36:
                    nextIndex = minIndex;
                    break;
                default:
                    return;
            }
            if (nextIndex !== index) {
                var _refs_items_nextIndex_current;
                event.preventDefault();
                (_refs_items_nextIndex_current = refs.items[nextIndex].current) === null || _refs_items_nextIndex_current === void 0 ? void 0 : _refs_items_nextIndex_current.focus();
            }
        }, [
            index,
            onIndexChange,
            disabled
        ]);
        return /*#__PURE__*/ React.createElement(TabsContext.Provider, {
            value: refs
        }, /*#__PURE__*/ React.createElement(ListComponent, _object_spread({
            ref: ref,
            onKeyDown: onKeyDown
        }, rest), items.map(function(param, i) {
            var label = param.label, contentLeft = param.contentLeft;
            return /*#__PURE__*/ React.createElement(ItemComponent, {
                key: i,
                isActive: i === index,
                tabIndex: !disabled && i === index ? 0 : -1,
                contentLeft: contentLeft,
                onFocus: onItemFocus,
                disabled: disabled
            }, label);
        })));
    });
}
